// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: essmodule/essmodule.proto

package openfmb.essmodule;

/**
 * <pre>
 * Specialized 61850 ZGEN class
 * </pre>
 *
 * Protobuf type {@code essmodule.ESSEventAndStatusZGEN}
 */
public final class ESSEventAndStatusZGEN extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:essmodule.ESSEventAndStatusZGEN)
    ESSEventAndStatusZGENOrBuilder {
private static final long serialVersionUID = 0L;
  // Use ESSEventAndStatusZGEN.newBuilder() to construct.
  private ESSEventAndStatusZGEN(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private ESSEventAndStatusZGEN() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new ESSEventAndStatusZGEN();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.essmodule.Essmodule.internal_static_essmodule_ESSEventAndStatusZGEN_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.essmodule.Essmodule.internal_static_essmodule_ESSEventAndStatusZGEN_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.essmodule.ESSEventAndStatusZGEN.class, openfmb.essmodule.ESSEventAndStatusZGEN.Builder.class);
  }

  public static final int LOGICALNODEFOREVENTANDSTATUS_FIELD_NUMBER = 1;
  private openfmb.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the logicalNodeForEventAndStatus field is set.
   */
  @java.lang.Override
  public boolean hasLogicalNodeForEventAndStatus() {
    return logicalNodeForEventAndStatus_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
   * @return The logicalNodeForEventAndStatus.
   */
  @java.lang.Override
  public openfmb.commonmodule.LogicalNodeForEventAndStatus getLogicalNodeForEventAndStatus() {
    return logicalNodeForEventAndStatus_ == null ? openfmb.commonmodule.LogicalNodeForEventAndStatus.getDefaultInstance() : logicalNodeForEventAndStatus_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.LogicalNodeForEventAndStatusOrBuilder getLogicalNodeForEventAndStatusOrBuilder() {
    return logicalNodeForEventAndStatus_ == null ? openfmb.commonmodule.LogicalNodeForEventAndStatus.getDefaultInstance() : logicalNodeForEventAndStatus_;
  }

  public static final int AUXPWRST_FIELD_NUMBER = 2;
  private openfmb.commonmodule.StatusSPS auxPwrSt_;
  /**
   * <pre>
   * DC Power On/Off Status; True = DC power on
   * </pre>
   *
   * <code>.commonmodule.StatusSPS AuxPwrSt = 2;</code>
   * @return Whether the auxPwrSt field is set.
   */
  @java.lang.Override
  public boolean hasAuxPwrSt() {
    return auxPwrSt_ != null;
  }
  /**
   * <pre>
   * DC Power On/Off Status; True = DC power on
   * </pre>
   *
   * <code>.commonmodule.StatusSPS AuxPwrSt = 2;</code>
   * @return The auxPwrSt.
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPS getAuxPwrSt() {
    return auxPwrSt_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : auxPwrSt_;
  }
  /**
   * <pre>
   * DC Power On/Off Status; True = DC power on
   * </pre>
   *
   * <code>.commonmodule.StatusSPS AuxPwrSt = 2;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPSOrBuilder getAuxPwrStOrBuilder() {
    return auxPwrSt_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : auxPwrSt_;
  }

  public static final int DYNAMICTEST_FIELD_NUMBER = 3;
  private openfmb.commonmodule.ENS_DynamicTestKind dynamicTest_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 3;</code>
   * @return Whether the dynamicTest field is set.
   */
  @java.lang.Override
  public boolean hasDynamicTest() {
    return dynamicTest_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 3;</code>
   * @return The dynamicTest.
   */
  @java.lang.Override
  public openfmb.commonmodule.ENS_DynamicTestKind getDynamicTest() {
    return dynamicTest_ == null ? openfmb.commonmodule.ENS_DynamicTestKind.getDefaultInstance() : dynamicTest_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 3;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ENS_DynamicTestKindOrBuilder getDynamicTestOrBuilder() {
    return dynamicTest_ == null ? openfmb.commonmodule.ENS_DynamicTestKind.getDefaultInstance() : dynamicTest_;
  }

  public static final int EMGSTOP_FIELD_NUMBER = 4;
  private openfmb.commonmodule.StatusSPS emgStop_;
  /**
   * <pre>
   * Emergency stop
   * </pre>
   *
   * <code>.commonmodule.StatusSPS EmgStop = 4;</code>
   * @return Whether the emgStop field is set.
   */
  @java.lang.Override
  public boolean hasEmgStop() {
    return emgStop_ != null;
  }
  /**
   * <pre>
   * Emergency stop
   * </pre>
   *
   * <code>.commonmodule.StatusSPS EmgStop = 4;</code>
   * @return The emgStop.
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPS getEmgStop() {
    return emgStop_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : emgStop_;
  }
  /**
   * <pre>
   * Emergency stop
   * </pre>
   *
   * <code>.commonmodule.StatusSPS EmgStop = 4;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPSOrBuilder getEmgStopOrBuilder() {
    return emgStop_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : emgStop_;
  }

  public static final int GNSYNST_FIELD_NUMBER = 5;
  private openfmb.commonmodule.StatusSPS gnSynSt_;
  /**
   * <pre>
   * Generator is synchronized to EPS, or not; True = Synchronized
   * </pre>
   *
   * <code>.commonmodule.StatusSPS GnSynSt = 5;</code>
   * @return Whether the gnSynSt field is set.
   */
  @java.lang.Override
  public boolean hasGnSynSt() {
    return gnSynSt_ != null;
  }
  /**
   * <pre>
   * Generator is synchronized to EPS, or not; True = Synchronized
   * </pre>
   *
   * <code>.commonmodule.StatusSPS GnSynSt = 5;</code>
   * @return The gnSynSt.
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPS getGnSynSt() {
    return gnSynSt_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : gnSynSt_;
  }
  /**
   * <pre>
   * Generator is synchronized to EPS, or not; True = Synchronized
   * </pre>
   *
   * <code>.commonmodule.StatusSPS GnSynSt = 5;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPSOrBuilder getGnSynStOrBuilder() {
    return gnSynSt_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : gnSynSt_;
  }

  public static final int POINTSTATUS_FIELD_NUMBER = 6;
  private openfmb.essmodule.ESSPointStatus pointStatus_;
  /**
   * <pre>
   * Point status
   * </pre>
   *
   * <code>.essmodule.ESSPointStatus PointStatus = 6;</code>
   * @return Whether the pointStatus field is set.
   */
  @java.lang.Override
  public boolean hasPointStatus() {
    return pointStatus_ != null;
  }
  /**
   * <pre>
   * Point status
   * </pre>
   *
   * <code>.essmodule.ESSPointStatus PointStatus = 6;</code>
   * @return The pointStatus.
   */
  @java.lang.Override
  public openfmb.essmodule.ESSPointStatus getPointStatus() {
    return pointStatus_ == null ? openfmb.essmodule.ESSPointStatus.getDefaultInstance() : pointStatus_;
  }
  /**
   * <pre>
   * Point status
   * </pre>
   *
   * <code>.essmodule.ESSPointStatus PointStatus = 6;</code>
   */
  @java.lang.Override
  public openfmb.essmodule.ESSPointStatusOrBuilder getPointStatusOrBuilder() {
    return pointStatus_ == null ? openfmb.essmodule.ESSPointStatus.getDefaultInstance() : pointStatus_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (logicalNodeForEventAndStatus_ != null) {
      output.writeMessage(1, getLogicalNodeForEventAndStatus());
    }
    if (auxPwrSt_ != null) {
      output.writeMessage(2, getAuxPwrSt());
    }
    if (dynamicTest_ != null) {
      output.writeMessage(3, getDynamicTest());
    }
    if (emgStop_ != null) {
      output.writeMessage(4, getEmgStop());
    }
    if (gnSynSt_ != null) {
      output.writeMessage(5, getGnSynSt());
    }
    if (pointStatus_ != null) {
      output.writeMessage(6, getPointStatus());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (logicalNodeForEventAndStatus_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getLogicalNodeForEventAndStatus());
    }
    if (auxPwrSt_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getAuxPwrSt());
    }
    if (dynamicTest_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getDynamicTest());
    }
    if (emgStop_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(4, getEmgStop());
    }
    if (gnSynSt_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(5, getGnSynSt());
    }
    if (pointStatus_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(6, getPointStatus());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.essmodule.ESSEventAndStatusZGEN)) {
      return super.equals(obj);
    }
    openfmb.essmodule.ESSEventAndStatusZGEN other = (openfmb.essmodule.ESSEventAndStatusZGEN) obj;

    if (hasLogicalNodeForEventAndStatus() != other.hasLogicalNodeForEventAndStatus()) return false;
    if (hasLogicalNodeForEventAndStatus()) {
      if (!getLogicalNodeForEventAndStatus()
          .equals(other.getLogicalNodeForEventAndStatus())) return false;
    }
    if (hasAuxPwrSt() != other.hasAuxPwrSt()) return false;
    if (hasAuxPwrSt()) {
      if (!getAuxPwrSt()
          .equals(other.getAuxPwrSt())) return false;
    }
    if (hasDynamicTest() != other.hasDynamicTest()) return false;
    if (hasDynamicTest()) {
      if (!getDynamicTest()
          .equals(other.getDynamicTest())) return false;
    }
    if (hasEmgStop() != other.hasEmgStop()) return false;
    if (hasEmgStop()) {
      if (!getEmgStop()
          .equals(other.getEmgStop())) return false;
    }
    if (hasGnSynSt() != other.hasGnSynSt()) return false;
    if (hasGnSynSt()) {
      if (!getGnSynSt()
          .equals(other.getGnSynSt())) return false;
    }
    if (hasPointStatus() != other.hasPointStatus()) return false;
    if (hasPointStatus()) {
      if (!getPointStatus()
          .equals(other.getPointStatus())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasLogicalNodeForEventAndStatus()) {
      hash = (37 * hash) + LOGICALNODEFOREVENTANDSTATUS_FIELD_NUMBER;
      hash = (53 * hash) + getLogicalNodeForEventAndStatus().hashCode();
    }
    if (hasAuxPwrSt()) {
      hash = (37 * hash) + AUXPWRST_FIELD_NUMBER;
      hash = (53 * hash) + getAuxPwrSt().hashCode();
    }
    if (hasDynamicTest()) {
      hash = (37 * hash) + DYNAMICTEST_FIELD_NUMBER;
      hash = (53 * hash) + getDynamicTest().hashCode();
    }
    if (hasEmgStop()) {
      hash = (37 * hash) + EMGSTOP_FIELD_NUMBER;
      hash = (53 * hash) + getEmgStop().hashCode();
    }
    if (hasGnSynSt()) {
      hash = (37 * hash) + GNSYNST_FIELD_NUMBER;
      hash = (53 * hash) + getGnSynSt().hashCode();
    }
    if (hasPointStatus()) {
      hash = (37 * hash) + POINTSTATUS_FIELD_NUMBER;
      hash = (53 * hash) + getPointStatus().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.essmodule.ESSEventAndStatusZGEN parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.ESSEventAndStatusZGEN parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.ESSEventAndStatusZGEN parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.ESSEventAndStatusZGEN parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.ESSEventAndStatusZGEN parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.ESSEventAndStatusZGEN parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.ESSEventAndStatusZGEN parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.ESSEventAndStatusZGEN parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.essmodule.ESSEventAndStatusZGEN parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.ESSEventAndStatusZGEN parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.essmodule.ESSEventAndStatusZGEN parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.ESSEventAndStatusZGEN parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.essmodule.ESSEventAndStatusZGEN prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Specialized 61850 ZGEN class
   * </pre>
   *
   * Protobuf type {@code essmodule.ESSEventAndStatusZGEN}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:essmodule.ESSEventAndStatusZGEN)
      openfmb.essmodule.ESSEventAndStatusZGENOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_ESSEventAndStatusZGEN_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_ESSEventAndStatusZGEN_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.essmodule.ESSEventAndStatusZGEN.class, openfmb.essmodule.ESSEventAndStatusZGEN.Builder.class);
    }

    // Construct using openfmb.essmodule.ESSEventAndStatusZGEN.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      logicalNodeForEventAndStatus_ = null;
      if (logicalNodeForEventAndStatusBuilder_ != null) {
        logicalNodeForEventAndStatusBuilder_.dispose();
        logicalNodeForEventAndStatusBuilder_ = null;
      }
      auxPwrSt_ = null;
      if (auxPwrStBuilder_ != null) {
        auxPwrStBuilder_.dispose();
        auxPwrStBuilder_ = null;
      }
      dynamicTest_ = null;
      if (dynamicTestBuilder_ != null) {
        dynamicTestBuilder_.dispose();
        dynamicTestBuilder_ = null;
      }
      emgStop_ = null;
      if (emgStopBuilder_ != null) {
        emgStopBuilder_.dispose();
        emgStopBuilder_ = null;
      }
      gnSynSt_ = null;
      if (gnSynStBuilder_ != null) {
        gnSynStBuilder_.dispose();
        gnSynStBuilder_ = null;
      }
      pointStatus_ = null;
      if (pointStatusBuilder_ != null) {
        pointStatusBuilder_.dispose();
        pointStatusBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_ESSEventAndStatusZGEN_descriptor;
    }

    @java.lang.Override
    public openfmb.essmodule.ESSEventAndStatusZGEN getDefaultInstanceForType() {
      return openfmb.essmodule.ESSEventAndStatusZGEN.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.essmodule.ESSEventAndStatusZGEN build() {
      openfmb.essmodule.ESSEventAndStatusZGEN result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.essmodule.ESSEventAndStatusZGEN buildPartial() {
      openfmb.essmodule.ESSEventAndStatusZGEN result = new openfmb.essmodule.ESSEventAndStatusZGEN(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.essmodule.ESSEventAndStatusZGEN result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.logicalNodeForEventAndStatus_ = logicalNodeForEventAndStatusBuilder_ == null
            ? logicalNodeForEventAndStatus_
            : logicalNodeForEventAndStatusBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.auxPwrSt_ = auxPwrStBuilder_ == null
            ? auxPwrSt_
            : auxPwrStBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.dynamicTest_ = dynamicTestBuilder_ == null
            ? dynamicTest_
            : dynamicTestBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000008) != 0)) {
        result.emgStop_ = emgStopBuilder_ == null
            ? emgStop_
            : emgStopBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000010) != 0)) {
        result.gnSynSt_ = gnSynStBuilder_ == null
            ? gnSynSt_
            : gnSynStBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000020) != 0)) {
        result.pointStatus_ = pointStatusBuilder_ == null
            ? pointStatus_
            : pointStatusBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.essmodule.ESSEventAndStatusZGEN) {
        return mergeFrom((openfmb.essmodule.ESSEventAndStatusZGEN)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.essmodule.ESSEventAndStatusZGEN other) {
      if (other == openfmb.essmodule.ESSEventAndStatusZGEN.getDefaultInstance()) return this;
      if (other.hasLogicalNodeForEventAndStatus()) {
        mergeLogicalNodeForEventAndStatus(other.getLogicalNodeForEventAndStatus());
      }
      if (other.hasAuxPwrSt()) {
        mergeAuxPwrSt(other.getAuxPwrSt());
      }
      if (other.hasDynamicTest()) {
        mergeDynamicTest(other.getDynamicTest());
      }
      if (other.hasEmgStop()) {
        mergeEmgStop(other.getEmgStop());
      }
      if (other.hasGnSynSt()) {
        mergeGnSynSt(other.getGnSynSt());
      }
      if (other.hasPointStatus()) {
        mergePointStatus(other.getPointStatus());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getLogicalNodeForEventAndStatusFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getAuxPwrStFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getDynamicTestFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            case 34: {
              input.readMessage(
                  getEmgStopFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000008;
              break;
            } // case 34
            case 42: {
              input.readMessage(
                  getGnSynStFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000010;
              break;
            } // case 42
            case 50: {
              input.readMessage(
                  getPointStatusFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000020;
              break;
            } // case 50
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.LogicalNodeForEventAndStatus, openfmb.commonmodule.LogicalNodeForEventAndStatus.Builder, openfmb.commonmodule.LogicalNodeForEventAndStatusOrBuilder> logicalNodeForEventAndStatusBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the logicalNodeForEventAndStatus field is set.
     */
    public boolean hasLogicalNodeForEventAndStatus() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     * @return The logicalNodeForEventAndStatus.
     */
    public openfmb.commonmodule.LogicalNodeForEventAndStatus getLogicalNodeForEventAndStatus() {
      if (logicalNodeForEventAndStatusBuilder_ == null) {
        return logicalNodeForEventAndStatus_ == null ? openfmb.commonmodule.LogicalNodeForEventAndStatus.getDefaultInstance() : logicalNodeForEventAndStatus_;
      } else {
        return logicalNodeForEventAndStatusBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setLogicalNodeForEventAndStatus(openfmb.commonmodule.LogicalNodeForEventAndStatus value) {
      if (logicalNodeForEventAndStatusBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        logicalNodeForEventAndStatus_ = value;
      } else {
        logicalNodeForEventAndStatusBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setLogicalNodeForEventAndStatus(
        openfmb.commonmodule.LogicalNodeForEventAndStatus.Builder builderForValue) {
      if (logicalNodeForEventAndStatusBuilder_ == null) {
        logicalNodeForEventAndStatus_ = builderForValue.build();
      } else {
        logicalNodeForEventAndStatusBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeLogicalNodeForEventAndStatus(openfmb.commonmodule.LogicalNodeForEventAndStatus value) {
      if (logicalNodeForEventAndStatusBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          logicalNodeForEventAndStatus_ != null &&
          logicalNodeForEventAndStatus_ != openfmb.commonmodule.LogicalNodeForEventAndStatus.getDefaultInstance()) {
          getLogicalNodeForEventAndStatusBuilder().mergeFrom(value);
        } else {
          logicalNodeForEventAndStatus_ = value;
        }
      } else {
        logicalNodeForEventAndStatusBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearLogicalNodeForEventAndStatus() {
      bitField0_ = (bitField0_ & ~0x00000001);
      logicalNodeForEventAndStatus_ = null;
      if (logicalNodeForEventAndStatusBuilder_ != null) {
        logicalNodeForEventAndStatusBuilder_.dispose();
        logicalNodeForEventAndStatusBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.LogicalNodeForEventAndStatus.Builder getLogicalNodeForEventAndStatusBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getLogicalNodeForEventAndStatusFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.LogicalNodeForEventAndStatusOrBuilder getLogicalNodeForEventAndStatusOrBuilder() {
      if (logicalNodeForEventAndStatusBuilder_ != null) {
        return logicalNodeForEventAndStatusBuilder_.getMessageOrBuilder();
      } else {
        return logicalNodeForEventAndStatus_ == null ?
            openfmb.commonmodule.LogicalNodeForEventAndStatus.getDefaultInstance() : logicalNodeForEventAndStatus_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.LogicalNodeForEventAndStatus, openfmb.commonmodule.LogicalNodeForEventAndStatus.Builder, openfmb.commonmodule.LogicalNodeForEventAndStatusOrBuilder> 
        getLogicalNodeForEventAndStatusFieldBuilder() {
      if (logicalNodeForEventAndStatusBuilder_ == null) {
        logicalNodeForEventAndStatusBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.LogicalNodeForEventAndStatus, openfmb.commonmodule.LogicalNodeForEventAndStatus.Builder, openfmb.commonmodule.LogicalNodeForEventAndStatusOrBuilder>(
                getLogicalNodeForEventAndStatus(),
                getParentForChildren(),
                isClean());
        logicalNodeForEventAndStatus_ = null;
      }
      return logicalNodeForEventAndStatusBuilder_;
    }

    private openfmb.commonmodule.StatusSPS auxPwrSt_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> auxPwrStBuilder_;
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.StatusSPS AuxPwrSt = 2;</code>
     * @return Whether the auxPwrSt field is set.
     */
    public boolean hasAuxPwrSt() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.StatusSPS AuxPwrSt = 2;</code>
     * @return The auxPwrSt.
     */
    public openfmb.commonmodule.StatusSPS getAuxPwrSt() {
      if (auxPwrStBuilder_ == null) {
        return auxPwrSt_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : auxPwrSt_;
      } else {
        return auxPwrStBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.StatusSPS AuxPwrSt = 2;</code>
     */
    public Builder setAuxPwrSt(openfmb.commonmodule.StatusSPS value) {
      if (auxPwrStBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        auxPwrSt_ = value;
      } else {
        auxPwrStBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.StatusSPS AuxPwrSt = 2;</code>
     */
    public Builder setAuxPwrSt(
        openfmb.commonmodule.StatusSPS.Builder builderForValue) {
      if (auxPwrStBuilder_ == null) {
        auxPwrSt_ = builderForValue.build();
      } else {
        auxPwrStBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.StatusSPS AuxPwrSt = 2;</code>
     */
    public Builder mergeAuxPwrSt(openfmb.commonmodule.StatusSPS value) {
      if (auxPwrStBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          auxPwrSt_ != null &&
          auxPwrSt_ != openfmb.commonmodule.StatusSPS.getDefaultInstance()) {
          getAuxPwrStBuilder().mergeFrom(value);
        } else {
          auxPwrSt_ = value;
        }
      } else {
        auxPwrStBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.StatusSPS AuxPwrSt = 2;</code>
     */
    public Builder clearAuxPwrSt() {
      bitField0_ = (bitField0_ & ~0x00000002);
      auxPwrSt_ = null;
      if (auxPwrStBuilder_ != null) {
        auxPwrStBuilder_.dispose();
        auxPwrStBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.StatusSPS AuxPwrSt = 2;</code>
     */
    public openfmb.commonmodule.StatusSPS.Builder getAuxPwrStBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getAuxPwrStFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.StatusSPS AuxPwrSt = 2;</code>
     */
    public openfmb.commonmodule.StatusSPSOrBuilder getAuxPwrStOrBuilder() {
      if (auxPwrStBuilder_ != null) {
        return auxPwrStBuilder_.getMessageOrBuilder();
      } else {
        return auxPwrSt_ == null ?
            openfmb.commonmodule.StatusSPS.getDefaultInstance() : auxPwrSt_;
      }
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.StatusSPS AuxPwrSt = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> 
        getAuxPwrStFieldBuilder() {
      if (auxPwrStBuilder_ == null) {
        auxPwrStBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder>(
                getAuxPwrSt(),
                getParentForChildren(),
                isClean());
        auxPwrSt_ = null;
      }
      return auxPwrStBuilder_;
    }

    private openfmb.commonmodule.ENS_DynamicTestKind dynamicTest_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ENS_DynamicTestKind, openfmb.commonmodule.ENS_DynamicTestKind.Builder, openfmb.commonmodule.ENS_DynamicTestKindOrBuilder> dynamicTestBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 3;</code>
     * @return Whether the dynamicTest field is set.
     */
    public boolean hasDynamicTest() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 3;</code>
     * @return The dynamicTest.
     */
    public openfmb.commonmodule.ENS_DynamicTestKind getDynamicTest() {
      if (dynamicTestBuilder_ == null) {
        return dynamicTest_ == null ? openfmb.commonmodule.ENS_DynamicTestKind.getDefaultInstance() : dynamicTest_;
      } else {
        return dynamicTestBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 3;</code>
     */
    public Builder setDynamicTest(openfmb.commonmodule.ENS_DynamicTestKind value) {
      if (dynamicTestBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        dynamicTest_ = value;
      } else {
        dynamicTestBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 3;</code>
     */
    public Builder setDynamicTest(
        openfmb.commonmodule.ENS_DynamicTestKind.Builder builderForValue) {
      if (dynamicTestBuilder_ == null) {
        dynamicTest_ = builderForValue.build();
      } else {
        dynamicTestBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 3;</code>
     */
    public Builder mergeDynamicTest(openfmb.commonmodule.ENS_DynamicTestKind value) {
      if (dynamicTestBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          dynamicTest_ != null &&
          dynamicTest_ != openfmb.commonmodule.ENS_DynamicTestKind.getDefaultInstance()) {
          getDynamicTestBuilder().mergeFrom(value);
        } else {
          dynamicTest_ = value;
        }
      } else {
        dynamicTestBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 3;</code>
     */
    public Builder clearDynamicTest() {
      bitField0_ = (bitField0_ & ~0x00000004);
      dynamicTest_ = null;
      if (dynamicTestBuilder_ != null) {
        dynamicTestBuilder_.dispose();
        dynamicTestBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 3;</code>
     */
    public openfmb.commonmodule.ENS_DynamicTestKind.Builder getDynamicTestBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getDynamicTestFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 3;</code>
     */
    public openfmb.commonmodule.ENS_DynamicTestKindOrBuilder getDynamicTestOrBuilder() {
      if (dynamicTestBuilder_ != null) {
        return dynamicTestBuilder_.getMessageOrBuilder();
      } else {
        return dynamicTest_ == null ?
            openfmb.commonmodule.ENS_DynamicTestKind.getDefaultInstance() : dynamicTest_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ENS_DynamicTestKind, openfmb.commonmodule.ENS_DynamicTestKind.Builder, openfmb.commonmodule.ENS_DynamicTestKindOrBuilder> 
        getDynamicTestFieldBuilder() {
      if (dynamicTestBuilder_ == null) {
        dynamicTestBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ENS_DynamicTestKind, openfmb.commonmodule.ENS_DynamicTestKind.Builder, openfmb.commonmodule.ENS_DynamicTestKindOrBuilder>(
                getDynamicTest(),
                getParentForChildren(),
                isClean());
        dynamicTest_ = null;
      }
      return dynamicTestBuilder_;
    }

    private openfmb.commonmodule.StatusSPS emgStop_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> emgStopBuilder_;
    /**
     * <pre>
     * Emergency stop
     * </pre>
     *
     * <code>.commonmodule.StatusSPS EmgStop = 4;</code>
     * @return Whether the emgStop field is set.
     */
    public boolean hasEmgStop() {
      return ((bitField0_ & 0x00000008) != 0);
    }
    /**
     * <pre>
     * Emergency stop
     * </pre>
     *
     * <code>.commonmodule.StatusSPS EmgStop = 4;</code>
     * @return The emgStop.
     */
    public openfmb.commonmodule.StatusSPS getEmgStop() {
      if (emgStopBuilder_ == null) {
        return emgStop_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : emgStop_;
      } else {
        return emgStopBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Emergency stop
     * </pre>
     *
     * <code>.commonmodule.StatusSPS EmgStop = 4;</code>
     */
    public Builder setEmgStop(openfmb.commonmodule.StatusSPS value) {
      if (emgStopBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        emgStop_ = value;
      } else {
        emgStopBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Emergency stop
     * </pre>
     *
     * <code>.commonmodule.StatusSPS EmgStop = 4;</code>
     */
    public Builder setEmgStop(
        openfmb.commonmodule.StatusSPS.Builder builderForValue) {
      if (emgStopBuilder_ == null) {
        emgStop_ = builderForValue.build();
      } else {
        emgStopBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Emergency stop
     * </pre>
     *
     * <code>.commonmodule.StatusSPS EmgStop = 4;</code>
     */
    public Builder mergeEmgStop(openfmb.commonmodule.StatusSPS value) {
      if (emgStopBuilder_ == null) {
        if (((bitField0_ & 0x00000008) != 0) &&
          emgStop_ != null &&
          emgStop_ != openfmb.commonmodule.StatusSPS.getDefaultInstance()) {
          getEmgStopBuilder().mergeFrom(value);
        } else {
          emgStop_ = value;
        }
      } else {
        emgStopBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Emergency stop
     * </pre>
     *
     * <code>.commonmodule.StatusSPS EmgStop = 4;</code>
     */
    public Builder clearEmgStop() {
      bitField0_ = (bitField0_ & ~0x00000008);
      emgStop_ = null;
      if (emgStopBuilder_ != null) {
        emgStopBuilder_.dispose();
        emgStopBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Emergency stop
     * </pre>
     *
     * <code>.commonmodule.StatusSPS EmgStop = 4;</code>
     */
    public openfmb.commonmodule.StatusSPS.Builder getEmgStopBuilder() {
      bitField0_ |= 0x00000008;
      onChanged();
      return getEmgStopFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Emergency stop
     * </pre>
     *
     * <code>.commonmodule.StatusSPS EmgStop = 4;</code>
     */
    public openfmb.commonmodule.StatusSPSOrBuilder getEmgStopOrBuilder() {
      if (emgStopBuilder_ != null) {
        return emgStopBuilder_.getMessageOrBuilder();
      } else {
        return emgStop_ == null ?
            openfmb.commonmodule.StatusSPS.getDefaultInstance() : emgStop_;
      }
    }
    /**
     * <pre>
     * Emergency stop
     * </pre>
     *
     * <code>.commonmodule.StatusSPS EmgStop = 4;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> 
        getEmgStopFieldBuilder() {
      if (emgStopBuilder_ == null) {
        emgStopBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder>(
                getEmgStop(),
                getParentForChildren(),
                isClean());
        emgStop_ = null;
      }
      return emgStopBuilder_;
    }

    private openfmb.commonmodule.StatusSPS gnSynSt_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> gnSynStBuilder_;
    /**
     * <pre>
     * Generator is synchronized to EPS, or not; True = Synchronized
     * </pre>
     *
     * <code>.commonmodule.StatusSPS GnSynSt = 5;</code>
     * @return Whether the gnSynSt field is set.
     */
    public boolean hasGnSynSt() {
      return ((bitField0_ & 0x00000010) != 0);
    }
    /**
     * <pre>
     * Generator is synchronized to EPS, or not; True = Synchronized
     * </pre>
     *
     * <code>.commonmodule.StatusSPS GnSynSt = 5;</code>
     * @return The gnSynSt.
     */
    public openfmb.commonmodule.StatusSPS getGnSynSt() {
      if (gnSynStBuilder_ == null) {
        return gnSynSt_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : gnSynSt_;
      } else {
        return gnSynStBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Generator is synchronized to EPS, or not; True = Synchronized
     * </pre>
     *
     * <code>.commonmodule.StatusSPS GnSynSt = 5;</code>
     */
    public Builder setGnSynSt(openfmb.commonmodule.StatusSPS value) {
      if (gnSynStBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        gnSynSt_ = value;
      } else {
        gnSynStBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Generator is synchronized to EPS, or not; True = Synchronized
     * </pre>
     *
     * <code>.commonmodule.StatusSPS GnSynSt = 5;</code>
     */
    public Builder setGnSynSt(
        openfmb.commonmodule.StatusSPS.Builder builderForValue) {
      if (gnSynStBuilder_ == null) {
        gnSynSt_ = builderForValue.build();
      } else {
        gnSynStBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Generator is synchronized to EPS, or not; True = Synchronized
     * </pre>
     *
     * <code>.commonmodule.StatusSPS GnSynSt = 5;</code>
     */
    public Builder mergeGnSynSt(openfmb.commonmodule.StatusSPS value) {
      if (gnSynStBuilder_ == null) {
        if (((bitField0_ & 0x00000010) != 0) &&
          gnSynSt_ != null &&
          gnSynSt_ != openfmb.commonmodule.StatusSPS.getDefaultInstance()) {
          getGnSynStBuilder().mergeFrom(value);
        } else {
          gnSynSt_ = value;
        }
      } else {
        gnSynStBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Generator is synchronized to EPS, or not; True = Synchronized
     * </pre>
     *
     * <code>.commonmodule.StatusSPS GnSynSt = 5;</code>
     */
    public Builder clearGnSynSt() {
      bitField0_ = (bitField0_ & ~0x00000010);
      gnSynSt_ = null;
      if (gnSynStBuilder_ != null) {
        gnSynStBuilder_.dispose();
        gnSynStBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Generator is synchronized to EPS, or not; True = Synchronized
     * </pre>
     *
     * <code>.commonmodule.StatusSPS GnSynSt = 5;</code>
     */
    public openfmb.commonmodule.StatusSPS.Builder getGnSynStBuilder() {
      bitField0_ |= 0x00000010;
      onChanged();
      return getGnSynStFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Generator is synchronized to EPS, or not; True = Synchronized
     * </pre>
     *
     * <code>.commonmodule.StatusSPS GnSynSt = 5;</code>
     */
    public openfmb.commonmodule.StatusSPSOrBuilder getGnSynStOrBuilder() {
      if (gnSynStBuilder_ != null) {
        return gnSynStBuilder_.getMessageOrBuilder();
      } else {
        return gnSynSt_ == null ?
            openfmb.commonmodule.StatusSPS.getDefaultInstance() : gnSynSt_;
      }
    }
    /**
     * <pre>
     * Generator is synchronized to EPS, or not; True = Synchronized
     * </pre>
     *
     * <code>.commonmodule.StatusSPS GnSynSt = 5;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> 
        getGnSynStFieldBuilder() {
      if (gnSynStBuilder_ == null) {
        gnSynStBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder>(
                getGnSynSt(),
                getParentForChildren(),
                isClean());
        gnSynSt_ = null;
      }
      return gnSynStBuilder_;
    }

    private openfmb.essmodule.ESSPointStatus pointStatus_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.essmodule.ESSPointStatus, openfmb.essmodule.ESSPointStatus.Builder, openfmb.essmodule.ESSPointStatusOrBuilder> pointStatusBuilder_;
    /**
     * <pre>
     * Point status
     * </pre>
     *
     * <code>.essmodule.ESSPointStatus PointStatus = 6;</code>
     * @return Whether the pointStatus field is set.
     */
    public boolean hasPointStatus() {
      return ((bitField0_ & 0x00000020) != 0);
    }
    /**
     * <pre>
     * Point status
     * </pre>
     *
     * <code>.essmodule.ESSPointStatus PointStatus = 6;</code>
     * @return The pointStatus.
     */
    public openfmb.essmodule.ESSPointStatus getPointStatus() {
      if (pointStatusBuilder_ == null) {
        return pointStatus_ == null ? openfmb.essmodule.ESSPointStatus.getDefaultInstance() : pointStatus_;
      } else {
        return pointStatusBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Point status
     * </pre>
     *
     * <code>.essmodule.ESSPointStatus PointStatus = 6;</code>
     */
    public Builder setPointStatus(openfmb.essmodule.ESSPointStatus value) {
      if (pointStatusBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        pointStatus_ = value;
      } else {
        pointStatusBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Point status
     * </pre>
     *
     * <code>.essmodule.ESSPointStatus PointStatus = 6;</code>
     */
    public Builder setPointStatus(
        openfmb.essmodule.ESSPointStatus.Builder builderForValue) {
      if (pointStatusBuilder_ == null) {
        pointStatus_ = builderForValue.build();
      } else {
        pointStatusBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Point status
     * </pre>
     *
     * <code>.essmodule.ESSPointStatus PointStatus = 6;</code>
     */
    public Builder mergePointStatus(openfmb.essmodule.ESSPointStatus value) {
      if (pointStatusBuilder_ == null) {
        if (((bitField0_ & 0x00000020) != 0) &&
          pointStatus_ != null &&
          pointStatus_ != openfmb.essmodule.ESSPointStatus.getDefaultInstance()) {
          getPointStatusBuilder().mergeFrom(value);
        } else {
          pointStatus_ = value;
        }
      } else {
        pointStatusBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Point status
     * </pre>
     *
     * <code>.essmodule.ESSPointStatus PointStatus = 6;</code>
     */
    public Builder clearPointStatus() {
      bitField0_ = (bitField0_ & ~0x00000020);
      pointStatus_ = null;
      if (pointStatusBuilder_ != null) {
        pointStatusBuilder_.dispose();
        pointStatusBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Point status
     * </pre>
     *
     * <code>.essmodule.ESSPointStatus PointStatus = 6;</code>
     */
    public openfmb.essmodule.ESSPointStatus.Builder getPointStatusBuilder() {
      bitField0_ |= 0x00000020;
      onChanged();
      return getPointStatusFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Point status
     * </pre>
     *
     * <code>.essmodule.ESSPointStatus PointStatus = 6;</code>
     */
    public openfmb.essmodule.ESSPointStatusOrBuilder getPointStatusOrBuilder() {
      if (pointStatusBuilder_ != null) {
        return pointStatusBuilder_.getMessageOrBuilder();
      } else {
        return pointStatus_ == null ?
            openfmb.essmodule.ESSPointStatus.getDefaultInstance() : pointStatus_;
      }
    }
    /**
     * <pre>
     * Point status
     * </pre>
     *
     * <code>.essmodule.ESSPointStatus PointStatus = 6;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.essmodule.ESSPointStatus, openfmb.essmodule.ESSPointStatus.Builder, openfmb.essmodule.ESSPointStatusOrBuilder> 
        getPointStatusFieldBuilder() {
      if (pointStatusBuilder_ == null) {
        pointStatusBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.essmodule.ESSPointStatus, openfmb.essmodule.ESSPointStatus.Builder, openfmb.essmodule.ESSPointStatusOrBuilder>(
                getPointStatus(),
                getParentForChildren(),
                isClean());
        pointStatus_ = null;
      }
      return pointStatusBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:essmodule.ESSEventAndStatusZGEN)
  }

  // @@protoc_insertion_point(class_scope:essmodule.ESSEventAndStatusZGEN)
  private static final openfmb.essmodule.ESSEventAndStatusZGEN DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.essmodule.ESSEventAndStatusZGEN();
  }

  public static openfmb.essmodule.ESSEventAndStatusZGEN getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<ESSEventAndStatusZGEN>
      PARSER = new com.google.protobuf.AbstractParser<ESSEventAndStatusZGEN>() {
    @java.lang.Override
    public ESSEventAndStatusZGEN parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<ESSEventAndStatusZGEN> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<ESSEventAndStatusZGEN> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.essmodule.ESSEventAndStatusZGEN getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

